<?php
if(!defined("PHORUM_CONTROL_CENTER")) return;

// if they are saving their disable setitngs
if (isset($_POST["disable_submit"])) {
        $user["mod_user_avatar"]["disable_avatar_display"] = ($_POST["disable_avatar_display"]==1) ? true : false;
        unset($user["password"]);
        unset($user["password_temp"]);
        phorum_user_save($user);
        $PHORUM["DATA"]["Message"] = $PHORUM["DATA"]["LANG"]["ChangesSaved"];
}

// if the user is saving their avatars, do this
elseif (isset($_POST["submit"])){
    // an avatar must be set
    if (!isset($_POST["avatar"])) {
        $PHORUM["DATA"]["Message"] = $PHORUM["DATA"]["LANG"]["mod_user_avatar"]["MissingAvatar"];
    } else {
        $user = phorum_user_get($PHORUM["user"]["user_id"]);
        $user["mod_user_avatar"]["avatar"] = (int) $_POST["avatar"];
        unset($user["password"]);
        unset($user["password_temp"]);
        phorum_user_save($user);
        $PHORUM["DATA"]["Message"] = $PHORUM["DATA"]["LANG"]["ChangesSaved"];
    }
}


// show the list of avatars they can use
$fullfilelist = phorum_db_get_user_file_list($PHORUM["user"]["user_id"]);
$filelist = array();
foreach ($fullfilelist as $fileid => $file){
    $extension = strtolower(substr($file["filename"], strrpos($file["filename"], ".") + 1));
    if (in_array($extension, $PHORUM["mod_user_avatar"]["file_types"]) && mod_user_avatar_check_dimensions($fileid)){
        $selected = false;

        if (isset($PHORUM["user"]["mod_user_avatar"]["avatar"])){
            $selected = ($fileid == $PHORUM["user"]["mod_user_avatar"]["avatar"]);
			$PHORUM['DATA']["mod_user_avatar"]["no_avatar_selected"] = FALSE;
        }

        $filelist[$fileid] = array("fileid" => $fileid,
           "selected" => $selected,
           "url" => phorum_get_url(PHORUM_FILE_URL, "file=" . $fileid)
        );
    }
}
$PHORUM['DATA']['mod_user_avatar'] = $PHORUM["mod_user_avatar"];
$PHORUM['DATA']["mod_user_avatar_filelist"] = $filelist;
$PHORUM['DATA']['mod_user_avatar']['valid_file_types'] = implode(", ", $PHORUM["mod_user_avatar"]["file_types"]);
$PHORUM['DATA']["mod_user_avatar"]["disable_avatar_display"] = $user["mod_user_avatar"]["disable_avatar_display"];
if (isset($PHORUM["user"]["mod_user_avatar"]["avatar"])) {
	$PHORUM['DATA']["mod_user_avatar"]["no_avatar_selected"] = ($PHORUM["user"]["mod_user_avatar"]["avatar"] == -1) ? TRUE : FALSE;
} else {
	$PHORUM["DATA"]["mod_user_avatar"]["no_avatar_selected"] = TRUE;
}
$template = "cc_mod_user_avatar";

/* 
This function is based on the picProcessor file created by pat on the phorum.org boards.
Thanks pat!

This function checks if an image is inside the maximum dimensions for avatars, and returns true if it is. */
function mod_user_avatar_check_dimensions($fileid)
{
    $PHORUM=$GLOBALS["PHORUM"];
    //error_reporting(0); // I don't mind what I don't see ;-)

    // getimagesize() requires a filename or a url, but we can cheat a little bit
    // admittadly, if url fopen is disabled, this will not work out very well
    $filename = phorum_get_url(PHORUM_FILE_URL, "file=" . $fileid);
    $imagedata = getimagesize($filename);

    // check if it's really an image just to make sure once again (security?)
    if (!$imagedata[2] || $imagedata[2] == 4 || $imagedata[2] == 5) {
        return false;
    }
    return ($imagedata[0] <= $PHORUM["mod_user_avatar"]["max_width"] && $imagedata[1] <= $PHORUM["mod_user_avatar"]["max_height"]);   
}
?>
