<?php
/*	mod_user_avatar: Allow users to have an avatar. This requires template support.
	author: Chris Eaton (tridus@hiredgoons.ca)
            Special thanks to pat!
	version: 2.1.1
	license: You are free to use, modify, or redistribute this code so long as I am given credit for the original development somewhere.
			 This code comes with absolutly no warranty.

			 It would be nice (but not required) of you to email me if you find this module useful. :-)
*/
if(!defined("PHORUM")) return;

// Sets up global configuration for mod_user_avatar.
function mod_user_avatar_common()
{
	GLOBAL $PHORUM;
	if(!$PHORUM["DATA"]["LOGGEDIN"]){
		return;
	}
    $PHORUM['DATA']['mod_user_avatar']['enabled'] = true;
    $PHORUM['mod_user_avatar']['url'] = phorum_get_url(PHORUM_CONTROLCENTER_URL, "panel=mod_user_avatar");
    $PHORUM['DATA']['mod_user_avatar']['url'] = $PHORUM['mod_user_avatar']['url'];
}

function mod_user_avatar_read($messages){
	GLOBAL $PHORUM;

    // if the user doesn't want to show avatars, we can disable them here
    $disable = false;
    if (isset($PHORUM["user"]["mod_user_avatar"]["disable_avatar_display"])) {
        $disable = $PHORUM["user"]["mod_user_avatar"]["disable_avatar_display"];
    }

    foreach ($messages as $messageid => $message) {
        // if the user has avatars disabled, don't display them
        if ($disable){
            $messages[$messageid]["mod_user_avatar"] = FALSE;
        } else {
			$author = phorum_user_get($message["user_id"]);
			if (!isset($author["mod_user_avatar"]["avatar"]) || $author["mod_user_avatar"]["avatar"] == -1) {
				$messages[$messageid]["mod_user_avatar"] = FALSE;
			} else {
				$filelist = phorum_db_get_user_file_list($message["user_id"]);
				if (isset($filelist[$author["mod_user_avatar"]["avatar"]])) {
					$messages[$messageid]["mod_user_avatar"] =
					phorum_get_url(PHORUM_FILE_URL, "file=" . $author["mod_user_avatar"]["avatar"]);
				} else {
					$messages[$messageid]["mod_user_avatar"] = FALSE;
				}
			}
		}
    }
    return $messages;
}

// profile hook
function mod_user_avatar_profile($profile)
{
    if (isset($profile["mod_user_avatar"]["avatar"])) {
        $profile["mod_user_avatar"] = phorum_get_url(PHORUM_FILE_URL, "file=" . $profile["mod_user_avatar"]["avatar"]);
    } else {
		$profile["mod_user_avatar"] = FALSE;
	}
    return $profile;
}